unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    SG: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure FormChangeBounds(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

type
  TTestAnsiString1 = type AnsiString(CP_ACP);     //   = 0;     // default to ANSI code page
  TTestAnsiString2 = type AnsiString(CP_OEMCP);   //   = 1;     // default to OEM (console) code page
  TTestAnsiString3 = type AnsiString(CP_UTF16);   //   = 1200;  // utf-16
  TTestAnsiString4 = type AnsiString(CP_UTF16BE); //   = 1201;  // unicodeFFFE
  TTestAnsiString5 = type AnsiString(CP_UTF7);    //   = 65000; // utf-7
  TTestAnsiString6 = type AnsiString(CP_UTF8);    //   = 65001; // utf-8
  TTestAnsiString7 = type AnsiString(CP_ASCII);   //   = 20127; // us-ascii
  TTestAnsiString8 = type AnsiString(CP_NONE);    //   = $FFFF; // rawbytestring encoding

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function MyChar(P:Pointer; Lang:Integer):String;
var
  i:Integer;
begin
  Result:='[';
  for i:=0 to Lang-1 do
    Result:=Result + Char(PByte(Cardinal(P) + i)^);
  Result:=Result+']';
end;

function ZeigeByte(P:Pointer; Lang:Integer):String;
var
  i:Integer;
begin
  Result:='';
  for i:=0 to Lang-1 do
    Result:=Result + IntToHex(PByte(Cardinal(P) + i)^, 2) + ' ';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Str:String;
  AStr:AnsiString;
  UStr:UnicodeString;
  UTStr:UTF8String;
  WStr:WideString;
  Test1:TTestAnsiString1;
  Test2:TTestAnsiString2;
  Test3:TTestAnsiString3;
  Test4:TTestAnsiString4;
  Test5:TTestAnsiString5;
  Test6:TTestAnsiString6;
  Test7:TTestAnsiString7;
  Test8:TTestAnsiString8;
begin

  Str:=Edit1.Text;
  SG.Cells[0,1]:='String [8Bit]';
  SG.Cells[1,1]:=Str;
  SG.Cells[2,1]:=IntToStr(Length(Str));
  SG.Cells[3,1]:=MyChar(pointer(Str), length(Str));
  SG.Cells[4,1]:=ZeigeByte(pointer(Str), length(Str));

  AStr:=Str;
  SG.Cells[0,2]:='AnsiString [8Bit]';
  SG.Cells[1,2]:=AStr;
  SG.Cells[2,2]:=IntToStr(Length(AStr));
  SG.Cells[3,2]:=MyChar(pointer(AStr), length(AStr));
  SG.Cells[4,2]:=ZeigeByte(pointer(AStr), length(AStr));

  UTStr:=Str;
  SG.Cells[0,3]:='UTF8String [8Bit]';
  SG.Cells[1,3]:=UTStr;
  SG.Cells[2,3]:=IntToStr(Length(UTStr));
  SG.Cells[3,3]:=MyChar(pointer(UTStr), length(UTStr));
  SG.Cells[4,3]:=ZeigeByte(pointer(UTStr), length(UTStr));

  UStr:=UnicodeString(Str);
  SG.Cells[0,4]:='UnicodeString [16Bit]';
  SG.Cells[1,4]:=AnsiString(UStr);
  SG.Cells[2,4]:=IntToStr(Length(UStr));
  SG.Cells[3,4]:=MyChar(pointer(UStr), length(UStr)*2);
  SG.Cells[4,4]:=ZeigeByte(pointer(UStr), length(UStr)*2);

  UStr:=Str;
  SG.Cells[0,5]:='UnicodeString direkt zugewiesen';
  SG.Cells[1,5]:=UStr;
  SG.Cells[2,5]:=IntToStr(Length(UStr));
  SG.Cells[3,5]:=MyChar(pointer(UStr), length(UStr)*2);
  SG.Cells[4,5]:=ZeigeByte(pointer(UStr), length(UStr)*2);

  WStr:=WideString(Str);
  SG.Cells[0,6]:='WideString [16Bit]';
  SG.Cells[1,6]:=AnsiString(WStr);
  SG.Cells[2,6]:=IntToStr(Length(WStr));
  SG.Cells[3,6]:=MyChar(pointer(WStr), length(WStr)*2);
  SG.Cells[4,6]:=ZeigeByte(pointer(WStr), length(WStr)*2);

  WStr:=Str;
  SG.Cells[0,7]:='WideString  direkt zugewiesen';
  SG.Cells[1,7]:=WStr;
  SG.Cells[2,7]:=IntToStr(Length(WStr));
  SG.Cells[3,7]:=MyChar(pointer(WStr), length(WStr)*2);
  SG.Cells[4,7]:=ZeigeByte(pointer(WStr), length(WStr)*2);

  Test1:=Str;
  SG.Cells[0,8]:='default to ANSI code page';
  SG.Cells[1,8]:=Test1;
  SG.Cells[2,8]:=IntToStr(Length(Test1));
  SG.Cells[3,8]:=MyChar(pointer(Test1), length(Test1));
  SG.Cells[4,8]:=ZeigeByte(pointer(Test1), length(Test1));

  Test2:=Str;
  SG.Cells[0,9]:='default to OEM (console) code page';
  SG.Cells[1,9]:=Test2;
  SG.Cells[2,9]:=IntToStr(Length(Test2));
  SG.Cells[3,9]:=MyChar(pointer(Test2), length(Test2));
  SG.Cells[4,9]:=ZeigeByte(pointer(Test2), length(Test2));

  Test3:=Str;
  SG.Cells[0,10]:='utf-16';
  SG.Cells[1,10]:=Test3;
  SG.Cells[2,10]:=IntToStr(Length(Test3));
  SG.Cells[3,10]:=MyChar(pointer(Test3), length(Test3));
  SG.Cells[4,10]:=ZeigeByte(pointer(Test3), length(Test3));

  Test4:=Str;
  SG.Cells[0,11]:='unicodeFFFE';
  SG.Cells[1,11]:=Test4;
  SG.Cells[2,11]:=IntToStr(Length(Test4));
  SG.Cells[3,11]:=MyChar(pointer(Test4), length(Test4));
  SG.Cells[4,11]:=ZeigeByte(pointer(Test4), length(Test4));

  Test5:=Str;
  SG.Cells[0,12]:='utf-7';
  SG.Cells[1,12]:=Test5;
  SG.Cells[2,12]:=IntToStr(Length(Test5));
  SG.Cells[3,12]:=MyChar(pointer(Test5), length(Test5));
  SG.Cells[4,12]:=ZeigeByte(pointer(Test5), length(Test5));

  Test6:=Str;
  SG.Cells[0,13]:='utf-8';
  SG.Cells[1,13]:=Test6;
  SG.Cells[2,13]:=IntToStr(Length(Test6));
  SG.Cells[3,13]:=MyChar(pointer(Test6), length(Test6));
  SG.Cells[4,13]:=ZeigeByte(pointer(Test6), length(Test6));

  Test7:=Str;
  SG.Cells[0,14]:='us-ascii';
  SG.Cells[1,14]:=Test7;
  SG.Cells[2,14]:=IntToStr(Length(Test7));
  SG.Cells[3,14]:=MyChar(pointer(Test7), length(Test7));
  SG.Cells[4,14]:=ZeigeByte(pointer(Test7), length(Test7));

  Test8:=Str;
  SG.Cells[0,15]:='rawbytestring encoding';
  SG.Cells[1,15]:=Test8;
  SG.Cells[2,15]:=IntToStr(Length(Test8));
  SG.Cells[3,15]:=MyChar(pointer(Test8), length(Test8));
  SG.Cells[4,15]:=ZeigeByte(pointer(Test8), length(Test8));

end;

procedure TForm1.FormChangeBounds(Sender: TObject);
begin
  SG.RowCount:=20;
  SG.ColWidths[0]:=ClientWidth*15 div 100;
  SG.ColWidths[1]:=ClientWidth*15 div 100;
  SG.ColWidths[2]:=ClientWidth*5 div 100;
  SG.ColWidths[3]:=ClientWidth*15 div 100;
  SG.ColWidths[4]:=ClientWidth*50 div 100;
end;

end.

